%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%
%%%%    		Deep Learning - Intro 
%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% TODO: 
%% 1. spiegare cosa è il Deep Learning
%% 2. spiegare perche abbiamo deciso di concentrare i nostri sforzi sulla convoluzione
%% 3. spiegare come è stato adattato l'algoritmo per l'architettura GPU like, casomai con figura


Deep Learning is a class of machine learning algorithms using convolutional neural networks (CNN) which are inspired by the behavior of optic nerves. Deep Learning gives state-of-the-art accuracy for many computer vision tasks, such as image classification and image search engine in data centers.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%
%%%%    		CNN and Conv Layer 
%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

CNN employs a feedforward process for recognition and a backward path for training. Consequently a typical CNN is composed of multiple computation layers, and the output $y$ is the sum of multiple different convolutions between the input $x$ and the filter $k$: 

%$$ y(i,j) = y(i,j) +  \sum_{u_i=0}^{u_i=K} \sum_{u_j=0}^{u_j=K} K(u_i,u_j)\times x(i-u_i, j-u_j) $$

$$ y[n] = x[n] \cdot k[n] = \sum_{k} x[n] \cdot k[n-k]
$$

This Chapter focuses on the exploration of different architectural features in a custom GPU-like accelerator targeted at convolution operations. In fact, these account for over 90\% of the processing in CNNs for both inference/testing and training~\cite{chen2017eyeriss}.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%
%%%%    		Conv Layer SIMDization
%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

The pseudo code of a convolution with a $K\times K$ filter with no stride, bi-dimensional input and output matrices, respectively of $N\times N$ and $M\times M$ where $M=N-K$, can be written as in the following listing:

\begin{lstlisting}[language=C, frame=lines]
for(row = 0; row < M; row++)
 for(col = 0; col < M; col++)
   for(krow = 0; krow < K; krow++)
     for(kcol = 0; kcol < K; kcol++)
       y[row][col] += k[krow][kcol] * 
              x[row + krow][col + kcol];
\end{lstlisting}

This scalar single-thread version of the convolution algorithm has been adapted to the target GPU-like architecture exploiting both thread and data level parallelism. Output matrix row calculations are equally spanned across all threads, i.e., for each thread, the outer loop starts with the thread ID (\texttt{thid}) and increments by the number of threads (\texttt{thnumb}). On the other hand, both input and output matrices are organized in target specific vector types, becoming vectors of vectors. Such an organization results in a distribution of the $M$ column partial results on the $M$ hardware lanes; each thread calculates $M$ partial results every cycle. The vectorization makes the second cycle unnecessary. The inner cycle, however, scrolls the input matrix in the scalar version. This can be replaced by a vectorial shift operation supported by the target architecture on the input row, which shifts each scalar element inside the hardware vector by $n$ positions. The resulting pseudo code of the algorithm optimized for a GPU-like accelerator, can be written as in the following listing:

\begin{lstlisting}[language=C, frame=lines]
for(row = thid; row < M; row += thnumb)
  for(krow = 0; krow < K; krow++)
    for(kcol = 0; kcol < K; kcol++) {
      y[row] += k[krow][kcol] * 
	      x[row + krow];
      x[row + krow] =  x[row+krow] << 1;
    }

\end{lstlisting}


